import { AutocompleteData, NS } from "@ns";
import {parse} from "./lib/flag";

/** @param {NS} ns */
export async function main(ns: NS): Promise<void> {
    const flag = parse(ns.args.map(String));
	if(flag._.length < 2){
		ns.tprint("argument required");
		ns.tprint("run cmd [src(hostname)] [dest(hostname)]");
		ns.exit();
	}
	const src = String(flag._[0]);
	const dest = String(flag._[1]);

    const th = flag.thread || false;

	ns.tprint(`scp /script/mining.js ${src}`);
	await ns.scp("/script/mining.js",src);
    let nThread;
	if(th){
        nThread = th;
    }
    else {
        nThread = calculateMaximumThread(ns, src, ns.getScriptRam("/script/mining.js", src));
    }
	const pid = ns.exec("/script/mining.js",src,nThread,nThread,dest);
	ns.tprint(pid," Process started.");
}

/**
 * @param {NS} ns
 * @param {string} dst
 * @param {number} amount the program ram 
 */
export function calculateMaximumThread(ns:NS,host:string,amount:number):number{
	const maxRam = ns.getServerMaxRam(host);
	const usedRam = ns.getServerUsedRam(host);
	const restRam = maxRam - usedRam;
    return Math.floor(restRam / amount);
}

// eslint-disable-next-line @typescript-eslint/no-unused-vars
export function autocomplete(data: AutocompleteData,args: string[]): string[]{
	return [...data.servers];
}